unit CTLE;

interface
uses Objects, Wizard;

type
 PControl       = ^TControl;
 TControl       = object(TObject)
  link          : text;
  strings       : TCollection;
  filename      : string;
  wasexist      : boolean;
  constructor   Init(FName: string; tinyload: boolean);
  procedure     Save;
  procedure     SetParam(param, value: string);
  procedure     DelParam(param: string);
  function      GetParam(param, default: string): string;
  function      GetMParam(param: string; index: longint): string;
  destructor    Done; virtual;
 end;

implementation
constructor TControl.Init;
 var
  s: string;
 begin
  inherited init;
  strings.init(1,1);
  wasexist:=false;
  tinyload:=false;
  {$I-}
  if ioresult<>0 then;
  assign(link,fname); reset(link);
  if ioresult=0 then
   while not eof(link) do
    begin
     wasexist:=true;
     readln(link,s);
     if (copy(s,1,1)=';') and (tinyload) then
      else
     strings.insert(newstr(s));
    end;
  filename:=fname;
  close(link); inoutres:=0;
 end;

procedure TControl.Save;
 procedure writeme(s: pstring); far;
  begin
   if s<>nil then writeln(link,s^);
  end;
 begin
  if ioresult<>0 then; {$I-}
  assign(link,filename); rewrite(link); if ioresult<>0 then exit;
  strings.foreach(@writeme);
  close(link);
 end;

destructor TControl.Done;
 procedure DoneThisStuff(S: PString); far;
  begin
   DisposeStr(S);
  end;
 begin
  inherited done;
  strings.ForEach(@DoneThisStuff);
  strings.DeleteAll;
  strings.done;
 end;

procedure TControl.SetParam;
 var
  S: PString;
  I: Integer;
  X: String;
 procedure SearchMe(st: PString); far;
  begin
   if St=Nil then exit;
   if Trim(StUpcase(ExtractWord(1,St^,['='])))=StUpcase(Param) then S:=St;
  end;
 begin
  param:=Trim((param));
  S:=Nil;
  strings.foreach(@SearchMe);
  if S=Nil then
   Strings.Insert(NewStr(Param+'='+Value))
  else
   begin
    I:=Strings.IndexOf(S);
    DisposeStr(S);
    Strings.AtPut(I,NewStr(Param+'='+Value));
   end;
 end;

procedure TControl.DelParam(param: string);
 var
  S: PString;
 procedure SearchMe(st: PString); far;
  begin
   if St=Nil then exit;
   if Trim(StUpcase(ExtractWord(1,St^,['='])))=Param then S:=St;
  end;
 begin
  param:=Trim(StUpcase(param));
  S:=Nil;
  strings.foreach(@SearchMe);
  if S<>Nil then Strings.Free(S);
 end;

function TControl.GetParam(param, default: string): string;
 var
  S: PString;
 procedure SearchMe(st: PString); far;
  begin
   if St=Nil then exit;
   if Trim(StUpcase(ExtractWord(1,St^,['='])))=Param then S:=St;
  end;
 begin
  param:=Trim(StUpcase(param));
  S:=Nil;
  strings.foreach(@SearchMe);
  if S<>Nil then
   GetParam:=ExtractWord(2,S^,['='])
  else
   GetParam:=Default;
 end;

function TControl.GetMParam(param: string; index: longint): string;
 var
  S: PString;
  I: longint;
 procedure SearchMe(st: PString); far;
  begin
   if St=Nil then exit;
   if Trim(StUpcase(ExtractWord(1,St^,['='])))=Param then
    begin
     Inc(I);
     if I=Index then S:=St;
    end;
  end;
 begin
  param:=Trim(StUpcase(param)); i:=0;
  S:=Nil;
  strings.foreach(@SearchMe);
  if S<>Nil then
   GetMParam:=ExtractWord(2,S^,['='])
  else
   GetMParam:='';
 end;

end.
