uses Crt, Wizard, MkOpen, MkMsgAbs, MkGlobT, CTLe, Objects, Dos, Strings;

var
 Netmail: AbsMsgPtr;
 Ini: TControl;

const
 Version = '1.6';

const
 oldMSGiD: Longint = $00000000;

{$q-}
function GetMSGiD: String;
 var
  Stamp: Longint;
{$ifdef os2}
  Year, Month, Day, Dow, Hour, Min, Sec, Sec100: Longint;
{$else}
  Year, Month, Day, Dow, Hour, Min, Sec, Sec100: Word;
{$endif}
 begin
  repeat
{$IfDef Win32}
   DecodeDate(Date, Year, Month, Day);
   DecodeTime(Time, Hour, Min, Sec, Sec100);
{$Else}
   GetDate(Year, Month, Day, Dow);
   GetTime(Hour, Min, Sec, Sec100);
{$EndIf}
   Stamp:=Longint(Year+10)*355*24*60*60;
   Stamp:=Stamp+Longint(Month)*30*24*60*60;
   Stamp:=Stamp+Longint(Day)*24*60*60;
   Stamp:=Stamp+Longint(Hour)*60*60;
   Stamp:=Stamp+Longint(Min)*60;
   Stamp:=Stamp+Longint(Sec);
   Stamp:=(Stamp shl 7) or (Sec100 and $7F);
  until oldMSGiD<>Stamp;
  oldMSGiD:=Stamp;
  GetMSGiD:=StLocase(HexL(Stamp));
 end;
{$q+}

procedure Error(N: Word);
 begin
  TextAttr:=$0C; Write('DERR', HexW(N),': ');
  TextAttr:=$07;
  case N of
   $0001: Writeln('cannot open netmail');
   $0002: Writeln('cannot close netmail');
   $0003: Writeln('cannot open configuration file');
   $0004: Writeln('cannot create packet');
  else
   WriteLn('reserved or unreleased error code ;)');
  end;
  Halt(242);
 end;

const
 pktOpened: Boolean = False;
var
 pkt: TBufStream;

{$I PKT.INC}

function xTractWord(N: Byte; S: string; WordDelims: CharSet): word;
 var
  A: Word;
 begin
  Str2Word(ExtractWord(N,S,WordDelims),A);
  xTractWord:=A;
 end;

procedure Process;
 var
  L: Longint;
  S, Area: String;
  Year,Month,Day,Zzz,Min,Hour,Sec: Word;
  Header: TPKTHeader;
  MsgHead: TPKTMessage;
  Mode, EmptyCount: Longint;
 const
  Months : array[1..12] of string[3] = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
 procedure Clean(var S: String);
  var
   K: Byte;
  begin
   for K:=1 to Length(S) do
    if S[K]=#0 then S[K]:=#32;
  end;
 procedure _writeZ(S: String);
  begin
   Clean(S);
   S:=S+#0;
   pkt.Write(S[1],Length(S));
  end;
 procedure _write(S: String);
  begin
   Clean(S);
   S:=S+#13;
   pkt.Write(S[1],Length(S));
  end;
 procedure Put(Section: String);
  var
   L: Longint;
   S: String;
   F: Text;
  begin
   L:=0;
   repeat
    Inc(L);
    S:=ini.GetMParam(Section,L);
    if S='' then Break;
   until 1=2;
   Dec(L);
   if L<1 then L:=1;
   L:=Random(L)+1;
   S:=ini.GetMParam(Section,L);
   if S='' then Exit;
   {$I-}
   Assign(F,S);
   Reset(F);
   if IOResult<>0 then Exit;
   while not eof(F) do
    begin
     ReadLn(F,S);
     _write(s);
    end;
   Close(F);
  end;
 var
  K: Longint;
  C: Char;
  Posted: Boolean;
 begin
  Posted:=False;
  L:=0;
  repeat
   Inc(L);
   S:=Ini.GetMParam('Echotag', L);
   if S = '' then Break;
   Delete(S, 1, Pos(' ', S));
   if S = '' then Continue;
   if Pos(S, Netmail^.GetSubj) = 0 then Continue;
   Netmail^.MsgTxtStartup;
   Posted:=True;
   Area:=StUpCase(ExtractWord(1,Ini.GetMParam('Echotag',L),[' ']));
   if not pktOpened then
    begin
     repeat
      S:=AddBackSlash(ini.GetParam('pktDir',''))+GetMSGId+'.PKT';
      if not ExistFile(S) then Break;
     until 1=2;
     pkt.Init(S,stCreate,2048);
     if pkt.Status<>stOk then Error($0004);
     pktOpened:=True;
     TextAttr:=$0E; Write('> ');
     TextAttr:=$0A; WriteLn('created packet ',S);
     GetDate(Year,Month,Day,Zzz);
     GetTime(Hour,Min,Sec,Zzz);
     FillChar(Header,SizeOf(Header),0);
     StrPCopy(PChar(@Header.Password),ini.GetParam('pktPassword',''));
     Header.OrigNode:=xtractWord(3,ini.GetParam('srcPKT',''),[':','/','.']);
     Header.DestNode:=xtractWord(3,ini.GetParam('destPKT',''),[':','/','.']);
     Header.OrigNet:=xtractWord(2,ini.GetParam('srcPKT',''),[':','/','.']);
     Header.DestNet:=xtractWord(2,ini.GetParam('destPKT',''),[':','/','.']);
     Header.Version:=2;
     Header.OrigZone:=xtractWord(1,ini.GetParam('srcPKT',''),[':','/','.']);
     Header.DestZone:=xtractWord(1,ini.GetParam('destPKT',''),[':','/','.']);
     Header.OrigPoint:=xtractWord(4,ini.GetParam('srcPKT',''),[':','/','.']);
     Header.DestPoint:=xtractWord(4,ini.GetParam('destPKT',''),[':','/','.']);
     Header.CWCapWord:=1;
     Header.CWValidate:=$100;
     Header.QMOrigZone:=Header.OrigZone;
     Header.QMDestZone:=Header.DestZone;
     Header.Year:=Year;
     Header.Month:=Month;
     Header.Day:=Day;
     Header.Hour:=Hour;
     Header.Minute:=Min;
     Header.Second:=Sec;
     pkt.Write(Header,SizeOf(Header));
    end;
   FillChar(MsgHead,SizeOf(MsgHead),0);
   MsgHead.origNode:=xtractWord(3,ini.GetParam('srcMSG',''),[':','/','.']);
   MsgHead.destNode:=xtractWord(3,ini.GetParam('destMSG',''),[':','/','.']);
   MsgHead.origNet:=xtractWord(2,ini.GetParam('srcMSG',''),[':','/','.']);
   MsgHead.destNet:=xtractWord(2,ini.GetParam('destMSG',''),[':','/','.']);
   MsgHead.Attribute:=0;
   MsgHead.Cost:=0;
   Zzz:=2;
   pkt.Write(Zzz,2);
   pkt.Write(MsgHead,SizeOf(MsgHead));
   GetDate(Year,Month,Day,Zzz);
   GetTime(Hour,Min,Sec,Zzz);
   S:=LeftPadCh(Long2Str(Day),'0',2)+' '+Copy(Months[Month],1,3)+' '+Copy(Long2Str(Year),3,2)+'  '+
      LeftPadCh(Long2Str(Hour),'0',2)+':'+LeftPadCh(Long2Str(Min),'0',2)+':'+LeftPadCh(Long2Str(Sec),'0',2);
   _writeZ(S);
   _writeZ(ini.GetParam('destMSGname',''));
   _writeZ(ini.GetParam('srcMSGname',''));
   _writeZ(netmail^.GetSubj);
   _write('AREA:'+Area);
   _write(#1'MSGID: '+ini.GetParam('srcMSG','')+' '+GetMSGID);
   _write(#1'PID: News Daemon v' + Version + ' (c) by Sergey Korowkin, 2:5033/27@fidonet, 1998-99.');
   Put('Header');
   Mode:=0;
   EmptyCount:=0;
   while (not Netmail^.EOM) do
    begin
     S:=Netmail^.GetString(255);
     if (Copy(S, 1, 64) = '      㦡 뫮 த᪮  / CityCat''s E-mail Service') then Continue else
     if (Copy(S, 1, 76) = '-*--------------------------------------------------------------------------') then Continue else
     if (Copy(S, 1, 76) = '---------------------------------------------------------------------') then Break else
     if (Copy(S, 1, 06) = 'From: ') then Continue else
     if (Copy(S, 1, 10) = 'Reply-To: ') then Continue else
     if (Copy(S, 1, 04) = 'Cc: ') then Continue else
     if (Copy(S, 1, 69) = 'ଠ樮 ࢥ "த᪮ " । ࠧ饭 ४') then Break else
     if (Copy(S, 1, 50) = 'http://www.citycat.ru/   mailto:citycat@citycat.ru') then Continue else
     if (Copy(S, 1, 01) = #1) then Continue else
     if (Copy(S, 1, 05) = 'CC: "') then Continue else
     if (Copy(S, 1, 37) = '㦡 뫮 ࢥ "What''s New?"') then Mode:=1 else
     if (Copy(S, 1, 48) = '--------------------  ४: web@wn.ru --') and (Mode = 1) then Mode:=0 else
     if (S = '----------------') and (Mode = 0) then Mode:=2 else
     if (S = 'http://www.wn.ru') and (Mode = 2) then Mode:=0 else
     if (Copy(S, 1, 45) = ' ᪨  ଠ ⭮ ࢥ') and (Mode = 0) then Mode:=3 else
     if (Copy(S, 1, 28) = 'http://www.wn.ru/mailservice') and (Mode = 3) then Mode:=0 else
     if Mode = 0 then
      begin
       if S = '' then
        Inc(EmptyCount)
       else
        begin
         { ---------- and so one cutting; remove it if you needn't it ;) }
         S:=Rtrim(S);
         C:=S[1];
         for K:=1 to Length(S) do
          if S[K] <> C then
           begin
            K:=0;
            Break;
           end;
         if K = 0 then
          if S <> '' then
           begin
            for K:=1 to EmptyCount do
             _write('');
            if Copy(S, 1, 3) = '---' then S[2]:='+';
            if Copy(S, 1, 10) = ' * Origin:' then S[2]:='+';
            if Copy(S, 1, 7) = 'SEEN-BY' then S[5]:='+';
            if Copy(S, 1, 1) = #1 then S[1]:='@';
            _write(S);
           end;
         EmptyCount:=0;
        end;
      end;
    end;
   Put('Footer');
   _write('--- News Daemon v' + Version + ', (c) by sk // [rAN] [2:5033/27], 1998-99.');
   _writeZ(' * Origin: *** Dark Stranger BBS *** ('+ini.GetParam('srcMSG','')+')'#13);
   TextAttr:=$0E; Write('>');
   TextAttr:=$0B; WriteLn(' posted message in ' + Area);
   ExitCode:=2;
  until False;
  if Posted then
   Netmail^.DeleteMsg;
 end;

procedure GetOrigEx(Netmail: AbsMsgPtr; var A: AddrType);
 var
  S: String;
 begin
  Netmail^.MsgTxtStartup;
  A.Zone:=0;
  A.Net:=0;
  A.Node:=0;
  A.Point:=0;
  while (not Netmail^.EOM) do
   begin
    S:=Netmail^.GetString(255);
    if Copy(S, 1, 5) = #1'INTL' then ParseAddr(ExtractWord(3, S, [' ']), A, A);
    if Copy(S, 1, 5) = #1'FMPT' then ParseAddr(PointlessAddrStr(A) + '.' + ExtractWord(2, S, [' ']), A, A);
   end;
  Netmail^.MsgTxtStartup;
 end;

var
 A: AddrType;
 B: AddrType;
 X: Word;
 F: File;
 O: Boolean;
 K: Longint;
 S: String;
begin
 DirectVideo:=False;
 ExitCode:=0;
 TextAttr:=$07; ClrScr;
 TextAttr:=$0F; WriteLn('News Daemon v' + Version + ', (c) by sk // [rAN] [2:5033/27], 1998-99.');
 TextAttr:=$07; WriteLn;
 TextAttr:=$0E; WriteLn('> startup');
 Ini.Init(ForceExtension(ParamStr(0),'CTL'),True);
 if not Ini.WasExist then Error($0003);
 if not OpenOrCreateMsgArea(Netmail, Ini.GetParam('NetMail', '')) then Error($0001);
 TextAttr:=$0E; WriteLn('> scanning netmail');
 {!}
 Netmail^.SetMailType(mmtNetmail);
 Netmail^.SeekFirst(1);
 while Netmail^.SeekFound do
  begin
   if ExitCode = 0 then ExitCode:=1;
   Netmail^.MsgStartUp;
   GetOrigEx(Netmail, A);
   TextAttr:=$0E; Write('>');
   TextAttr:=$0A; Write(' found message from "');
   TextAttr:=$0F; Write(Netmail^.GetFrom);
   TextAttr:=$0A; Write('", "');
   TextAttr:=$0F; Write(AddrStr(A));
   TextAttr:=$0A; Write('"');
   O:=False;
   K:=0;
   repeat
    Inc(K);
    S:=ini.GetMParam('srcAddr', K);
    if S = '' then Break;
    S:=Trim(StUpcase(S));
    B.Zone:=0;
    B.Net:=0;
    B.Node:=0;
    B.Point:=0;
    ParseAddr(S, B, B);
    if (A.Zone = B.Zone) and (A.Net = B.Net) and (A.Node = B.Node) and (A.Point = B.Point) then
     begin
      O:=True;
      Break;
     end;
   until False;
   if not O then
    begin
     TextAttr:=$0C;
     WriteLn(' no [A].');
    end
   else
    begin
     O:=False;
     K:=0;
     repeat
      Inc(K);
      S:=ini.GetMParam('srcFrom', K);
      if S = '' then Break;
      S:=Trim(StUpcase(S));
      if (S = Trim(StUpcase(Netmail^.GetFrom))) then
       begin
        O:=True;
        Break;
       end;
     until False;
     if not O then
      begin
       TextAttr:=$0C;
       WriteLn(' no [N].');
      end
     else
      begin
       TextAttr:=$0C;
       WriteLn(' yes!');
       Process;
      end;
    end;
   Netmail^.SeekNext;
  end;
 {!}
 TextAttr:=$0E; WriteLn(#13#10'> shutdown');
 if pktOpened then
  begin
   X:=0;
   pkt.Write(X,2);
   pkt.Done;
   if ini.GetParam('Touch','')<>'' then
    begin
     Assign(F,ini.GetParam('Touch',''));
     Rewrite(F,1);
     Close(F);
    end;
  end;
 Ini.Done;
 if not CloseMsgArea(Netmail) then Error($0002);
 TextAttr:=$0A; WriteLn('> exiting with errorlevel ', ExitCode);
end.