{$S+}
unit Wizard;

interface
{$ifdef win32}
{$hints off}
{$h-}
{$endif}

{$ifdef msdos}
{$define dos}
{$endif}
{$ifdef dpmi}
{$define dos}
{$endif}

{$ifdef os2}
uses
     Use32,
     DoNotUse32,
     Os2Base,
     Dos;
{$endif}
{$ifdef dos}
uses
     Dos;
{$endif}

{$ifdef win32}
uses
     SysUtils,
     Windows;
{$endif}

const
  mfdDay                        = $001F;
  sfdDay                        = 0;
  mfdMonth                      = $01E0;
  sfdMonth                      = 5;
  mfdYear                       = $FE00;
  sfdYear                       = 9;
const
  mftTwoSecs                    = $001F;
  sftTwoSecs                    = 0;
  mftMinutes                    = $07E0;
  sftMinutes                    = 5;
  mftHours                      = $F800;
  sftHours                      = 11;

type
 CharSet = set of Char;
{$IFDEF win32}
 SearchRec = TSearchRec;
const
 AnyFile = faAnyFile;
 Directory = faDirectory;
 VolumeID = faVolumeID;
 Archive = faArchive;
 ReadOnly = faReadOnly;
var
 DosError: Word;
type
 DateTime = record
  Hour, Min, Sec, Year, Month, Day: Word;
 end;
{$ENDIF}
var
 Replaced: Boolean;
const
 DosDelimSet : set of Char = ['\', ':', #0];
 Months : array[1..12] of string[3] = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
type
{$ifdef os2}
 xWord = Longint;
{$else}
 xWord = Word;
{$endif}

function stUpcase(S: String): String;
function stLocase(S: String): String;
function Long2Str(L: Longint): String;
procedure stUpcaseEx(var S: String);
procedure stLocaseEx(var S: String);
procedure Str2Byte(S: String; var A: Byte);
procedure Str2Word(S: String; var A: Word);
procedure Str2Longint(S: String; var A: Longint);
function WordCount(S : string; WordDelims : CharSet) : Byte;
function ExtractWord(N : Byte; S : string; WordDelims : CharSet) : string;
function AddBackSlash(S: String): String;
function RTrim(S: String): String;
function LTrim(S: String): String;
function Trim(S: String): String;
procedure TrimEx(var S: String);
function PadCh(S : string; Ch : Char; Len : Byte) : string;
function Pad(S : string; Len : Byte) : string;
function LeftPadCh(S : string; Ch : Char; Len : Byte) : string;
function LeftPad(S : string; Len : Byte) : string;
function JustFilename(PathName : string) : string;
function JustPathname(PathName : string) : string;
function JustExtension(Name : string) : string;
function HasExtension(Name : string; var DotPos : Word) : Boolean;
function ForceExtension(Name, Ext: string): string;
function ExistFile(S: String): Boolean;
function GetFileSize(S: String): Longint;
function ExistDir(S: String): Boolean;
function HexB(B: Byte): string;
function HexW(W: Word): string;
function HexL(L: LongInt): string;
function HexPtr(P: Pointer): string;
function Replace(_Source, _What, _To: String): String;
procedure ReplaceEx(var _Source: String; _What, _To: String);
function Center(S : string; Width : Byte) : string;
function CenterCh(S : string; Ch : Char; Width : Byte) : string;
function GetPString(S: Pointer): String;
procedure GetPStringEx(S: Pointer; var R: String);
function GetFileDate(FName: String): longint;
function _Date(L: Longint): String;
function _Time(L: Longint): String;
function Long2StrFmt(L: Longint): String;
FUNCTION DayOfWeek (y, m, d : WORD) : WORD;
function GetAllAfterSpace(S: String; Spc: Byte): String;
function GetAllAfterChar(S: String; Spc: Byte; Ch: Char): String;
function Str2Number(S: String): Boolean;
{$IFNDEF win32}
procedure Wait(M: Longint);
{$ENDIF}
procedure IWannaDate(var D, M, Y: Word);
procedure IWannaTime(var H, M, S: Word);
function FExpand(const S: String): String;
{$ifdef win32}
function MemAvail: longint;
procedure FindFirst(Mask: String; Attr: Word; var SR: SearchRec);
procedure FindNext(var SR: SearchRec);
procedure FindClose(var SR: SearchRec);
{$endif}
{$ifdef dos}
procedure FindClose(var SR: SearchRec);
{$endif}
function StackOverflow: boolean;
function RemoveBackSlash(S: String): String;
function Str2Char(S: String): Char;
function TimeFix: longint;
procedure TimeDif(L: Longint; var DT: DateTime);
FUNCTION Clock: LONGINT;
function GetPktDateTime: string;
function GetPktDateTimeCustom(Day, Month, Year, Hour, Min, Sec: Word): string;
procedure ParsePktDateTime(S: String; var Day, Month, Year, Hour, Min, Sec, Dow: Word);
function GetStamp(const FName: String): Longint;
procedure SetStamp(const FName: String; K: Longint);

{$ifdef win32}
procedure UnpackTime(P: Longint; var T: DateTime);
procedure PackTime(var T: DateTime; var P: Longint);
function GetEnv(const Name: String): String;
{$endif}

implementation

function UpCase(c: char): char;                 {1996 year}
 begin;
  case c of
   'a'..'z': c:=chr(ord(c)-(97-65));
   ''..'': c:=chr(ord(c)-(160-128));
   ''..'': c:=chr(ord(c)-(224-144));
   '': c:='';
  end;
  upCase:=c;
 end;

function LoCase(c: char): char;                 {1996 year}
 begin;
  case c of
   'A'..'Z': c:=chr(ord(c)+(97-65));
   ''..'': c:=chr(ord(c)+(160-128));
   ''..'': c:=chr(ord(c)+(224-144));
   '': c:='';
  end;
  loCase:=c;
 end;

function stUpcase;
 var
  k: byte;
 begin
  for k:=1 to Length(S) do
   s[k]:=upcase(s[k]);
  stUpcase:=S;
 end;

function stLocase;
 var
  k: byte;
 begin
  for k:=1 to Length(S) do
   s[k]:=locase(s[k]);
  stLocase:=S;
 end;

procedure stUpcaseEx;
 var
  k: byte;
 begin
  for k:=1 to Length(S) do
   s[k]:=upcase(s[k]);
 end;

procedure stLocaseEx;
 var
  k: byte;
 begin
  for k:=1 to Length(S) do
   s[k]:=locase(s[k]);
 end;

function Long2Str;
 var
  S: String;
 begin
  Str(L, S);
  Long2str:=S;
 end;

var
{$IFDEF OS2}
 L: Longint;
{$ENDIF}
{$IFDEF DOS}
 L: Word;
{$ENDIF}
{$IFDEF win32}
 L: Integer;
{$ENDIF}

procedure Str2Word;
 begin
  if S='' then
   A:=0
  else
   Val(S,A,L);
 end;

procedure Str2Byte;
 begin
  if S='' then
   A:=0
  else
   Val(S,A,L);
 end;

procedure Str2Longint;
 begin
  if S='' then
   A:=0
  else
   Val(S,A,L);
 end;

function WordCount(S : string; WordDelims : CharSet) : Byte;
var
 Count : Byte;
 I : Word;
 SLen : Byte absolute S;
begin
 Count := 0;
 I := 1;
 while I <= SLen do begin
  while (I <= SLen) and (S[I] in WordDelims) do
   Inc(I);
   if I <= SLen then Inc(Count);
   while (I <= SLen) and not(S[I] in WordDelims) do
    Inc(I);
   end;
  WordCount := Count;
 end;

  function ExtractWord(N : Byte; S : string; WordDelims : CharSet) : string;
    {-Given a set of word delimiters, return the N'th word in S}
  var
    I : Word;                 {!!.12}
    Count, Len : Byte;
    SLen : Byte absolute S;
  begin
    Count := 0;
    I := 1;
    Len := 0;
    ExtractWord[0] := #0;

    while (I <= SLen) and (Count <> N) do begin
      {skip over delimiters}
      while (I <= SLen) and (S[I] in WordDelims) do
        Inc(I);

      {if we're not beyond end of S, we're at the start of a word}
      if I <= SLen then
        Inc(Count);

      {find the end of the current word}
      while (I <= SLen) and not(S[I] in WordDelims) do begin
        {if this is the N'th word, add the I'th character to Tmp}
        if Count = N then begin
          Inc(Len);
          ExtractWord[0] := Char(Len);
          ExtractWord[Len] := S[I];
        end;

        Inc(I);
      end;
    end;
  end;

function AddBackSlash;
 begin
  if S[0]<>#0 then
   if S[Length(S)]<>'\' then S:=S+'\';
  AddBackSlash:=S;
 end;

function LTrim(S: String): String;
 begin
  while (Length(S)<>0) and (S[1]=' ') do Delete(S,1,1);
  LTrim:=S;
 end;

function RTrim(S: String): String;
 begin
  while (Length(S)<>0) and (S[Length(S)]=' ') do Dec(S[0]);
  RTrim:=S;
 end;

function Trim;
 begin
  while (Length(S)<>0) and (S[1]=' ') do Delete(S,1,1);
  while (Length(S)<>0) and (S[Length(S)]=' ') do Dec(S[0]);
  Trim:=S;
 end;

procedure TrimEx(var S: String);
 begin
  while (Length(S)<>0) and (S[1]=' ') do Delete(S,1,1);
  while (Length(S)<>0) and (S[Length(S)]=' ') do Dec(S[0]);
 end;

function PadCh(S : string; Ch : Char; Len : Byte) : string;
  {-Return a string right-padded to length len with ch}
var
  O : string;
  SLen : Byte absolute S;
begin
  if Length(S) >= Len then
    PadCh := S
  else begin
    O[0]:=Chr(Len);
    Move(S[1], o[1], SLen);
    if SLen < 255 then
      FillChar(o[Succ(SLen)], Len-SLen, Ch);
    PadCh := o;
  end;
end;
 function Pad(S : string; Len : Byte) : string;
  {-Return a string right-padded to length len with blanks}
begin
  Pad := PadCh(S, ' ', Len);
end;
 function LeftPadCh(S : string; Ch : Char; Len : Byte) : string;
  {-Return a string left-padded to length len with ch}
var
  O : string;
  SLen : Byte absolute S;
begin
  if Length(S) >= Len then
    LeftPadCh := S
  else if SLen < 255 then begin
    O[0]:=Chr(Len);
    Move(S[1], o[Succ(Word(Len))-SLen], SLen);
    FillChar(o[1], Len-SLen, Ch);
    LeftPadCh := o;
  end;
end;

function LeftPad(S : string; Len : Byte) : string;
begin
 LeftPad:=LeftPadCh(S, ' ', Len);
end;

function JustExtension(Name: string): string;
var
  DotPos: Word;
begin
 if HasExtension(Name, DotPos) then
  JustExtension:=Copy(Name, Succ(DotPos), 3)
 else
  JustExtension[0] := #0;
end;

function JustFilename(PathName : string) : string;
 var
  I : Word;
begin
 I := Succ(Word(Length(PathName)));
 repeat
  Dec(I);
 until (PathName[I] in DosDelimSet) or (I = 0);
 JustFilename := Copy(PathName, Succ(I), 64);
end;

function JustPathname(PathName : string) : string;
var
 I : Word;
begin
 I := Succ(Word(Length(PathName)));
 repeat Dec(I); until (PathName[I] in DosDelimSet) or (I = 0);
 if I = 0 then JustPathname[0] := #0
 else if I = 1 then JustPathname := PathName[1]
 else if (PathName[I] = '\') then begin
 if PathName[Pred(I)] = ':' then JustPathname := Copy(PathName, 1, I)
 else JustPathname := Copy(PathName, 1, Pred(I));
 end else JustPathname := Copy(PathName, 1, I);
end;

function HasExtension(Name : string; var DotPos : Word) : Boolean;
var
 I : Word;
begin
 DotPos := 0;
 for I := Length(Name) downto 1 do
  if (Name[I] = '.') and (DotPos = 0) then
    DotPos := I;
 HasExtension := (DotPos > 0) and (Pos('\', Copy(Name, Succ(DotPos), 64)) = 0);
end;

function ForceExtension(Name, Ext : string) : string;
var
 DotPos : Word;
begin
 if HasExtension(Name, DotPos) then
  ForceExtension := Copy(Name, 1, DotPos)+Ext
 else
  ForceExtension := Name+'.'+Ext;
end;

function ExistFile(S: String): Boolean;
{$IFNDEF WIN32}
 var
  F: File;
{$IFDEF OS2}
  A: Use32.Word;
{$ELSE}
  A: Word;
{$ENDIF}
{$ENDIF}
 begin
{$IFDEF win32}
  ExistFile:=FileExists(S);
{$ELSE}
  Assign(F,S);
  GetFAttr(F,A);
  ExistFile:=DosError=0;
{$ENDIF}
 end;

const
  Digits : array[0..$F] of Char = '0123456789ABCDEF';
type
 Long =
  record
   LowWord, HighWord : Word;
  end;

function HexB(B : Byte) : string;
 begin
  HexB[0]:=#2;
  HexB[1]:=Digits[B shr 4];
  HexB[2]:=Digits[B and $F];
 end;

function HexW(W : Word) : string;
 begin
  HexW[0]:=#4;
  HexW[1]:=Digits[hi(W) shr 4];
  HexW[2]:=Digits[hi(W) and $F];
  HexW[3]:=Digits[lo(W) shr 4];
  HexW[4]:=Digits[lo(W) and $F];
 end;

function HexL(L : LongInt) : string;
 begin
  with Long(L) do
   HexL:=HexW(HighWord)+HexW(LowWord);
 end;

function HexPtr(P : Pointer) : string;
 var
  Z: Record S,O: Word end absolute P;
 begin
  HexPtr:=HexW(Z.S)+':'+HexW(Z.o);
 end;

function ExistDir(S: String): Boolean;
 var
  SR: SearchRec;
 begin
  FindFirst(AddBackSlash(S)+'*.*',AnyFile,SR);
  ExistDir:=DosError=0;
  FindClose(Sr);
 end;

function Replace(_Source, _What, _To: String): String;
 var
  I: Integer;
  X: Integer;
 begin
  _What:=StUpcase(_What);
  X:=0;
  Replaced:=False;
  repeat
   Inc(X);
   if X = 255 then Break;
   I:=Pos(_What, StUpcase(_Source));
   if I = 0 then Break;
   Delete(_Source, I, Length(_What));
   Insert(_To, _Source, I);
   Replaced:=True;
  until False;
  Replace:=_Source;
 end;

procedure ReplaceEx(var _Source: String; _What, _To: String);
 var
  I: Integer;
  X: Integer;
 begin
  _What:=StUpcase(_What);
  X:=0;
  Replaced:=False;
  repeat
   Inc(X);
   if X = 255 then Break;
   I:=Pos(_What, StUpcase(_Source));
   if I = 0 then Break;
   Delete(_Source, I, Length(_What));
   Insert(_To, _Source, I);
   Replaced:=True;
  until False;
 end;

function CenterCh(S : string; Ch : Char; Width : Byte) : string;
  var
    o : string;
    SLen : Byte absolute S;
  begin
    if SLen >= Width then
      CenterCh := S
    else if SLen < 255 then begin
      o[0] := Chr(Width);
      FillChar(o[1], Width, Ch);
      Move(S[1], o[Succ((Width-SLen) shr 1)], SLen);
      CenterCh := o;
    end;
  end;

function Center(S : string; Width : Byte) : string;
 begin
  Center := CenterCh(S, ' ', Width);
 end;

function GetPString(S: Pointer): String;
 type
  PString = ^String;
 begin
  if S=Nil then
   GetPString:=''
  else
   GetPString:=PString(S)^;
 end;

procedure GetPStringEx(S: Pointer; var R: String);
 type
  PString = ^String;
 begin
  if S=Nil then
   R[0]:=#0
  else
   R:=PString(S)^;
 end;

function GetFileDate(FName: String): longint;
 var
  Sr: SearchRec;
 begin
  FindFirst(FName,AnyFile,Sr);
  GetFileDate:=Sr.Time;
  FindClose(Sr);
 end;

function _Date;
{$IFDEF win32}
 begin
  _Date:=DateTimeToStr(L);
 end;
{$ELSE}
 var
  DT: DateTime;
 begin
  UnpackTime(L,DT);
  _Date:=LeftPadCh(Long2Str(DT.Day),'0',2)+'.'+LeftPadCh(Long2Str(DT.Month),'0',2)+'.'+Long2Str(DT.Year);
 end;
{$ENDIF}

function _Time;
{$IFDEF win32}
 begin
  _Time:=DateTimeToStr(L);
 end;
{$ELSE}
 var
  DT: DateTime;
 begin
   UnpackTime(L,DT);
  _Time:=LeftPadCh(Long2Str(DT.Hour),'0',2)+':'+LeftPadCh(Long2Str(DT.Min),'0',2);
 end;
{$ENDIF}

function Long2StrFMT;
 var
  K: Byte;
  S, R: String;
  Minus: Boolean;
 begin
  R:=Long2Str(L);
  S:='';
  L:=0;
  for K:=Length(R) downto 1 do
   begin
    S:=R[K]+S;
    Inc(L);
    if L=3 then
     begin
      S:=','+S;
      L:=0;
     end;
   end;
  Minus:=Copy(S, 1, 1)='-';
  if Minus then Delete(S, 1, 1);
  while Copy(S,1,1)=',' do Delete(S,1,1);
  if Minus then S:='-'+S;
  Long2StrFMT:=S;
 end;

function DayOfWeek(y, m, d :WORD) :WORD;
var
 Tmp1, Tmp2, yy, mm, dd : LONGINT;
begin
 yy := y;
 mm := m;
 dd := d;
 Tmp1 := mm + 10;
 Tmp2 := yy + (mm - 14) DIV 12;
 DayOfWeek :=  ((13 *  (Tmp1 - Tmp1 DIV 13 * 12) - 1) DIV 5 +
               dd + 77 + 5 * (Tmp2 - Tmp2 DIV 100 * 100) DIV 4 +
               Tmp2 DIV 400 - Tmp2 DIV 100 * 2) MOD 7;
end;

function GetAllAfterSpace(S: String; Spc: Byte): String;
 var
  K, L: Byte;
  Out: String;
 begin
  Out:=''; L:=0;
  for K:=1 to Length(S) do
   if L>=Spc then Out:=Out+S[K] else if S[K]=' ' then Inc(L);
  GetAllAfterSpace:=Out;
 end;

function GetAllAfterChar(S: String; Spc: Byte; Ch: Char): String;
 var
  K, L: Byte;
  Out: String;
 begin
  Out:=''; L:=0;
  for K:=1 to Length(S) do
   if L>=Spc then Out:=Out+S[K] else if S[K]=Ch then Inc(L);
  GetAllAfterChar:=Out;
 end;

function FExpand(const S: String): String;
 begin
{$IFDEF Win32}
  FExpand:=ExpandFileName(S);
{$ENDIF}
{$IFDEF DOS}
  FExpand:=Dos.FExpand(S);
{$ENDIF}
{$IFDEF OS2}
  FExpand:=Dos.FExpand(S);
{$ENDIF}
 end;

{$ifndef win32}
{$ifndef OS2}
FUNCTION Clock: LONGINT; ASSEMBLER;
ASM
             PUSH    DS              { save caller's data segment }
             MOV     DS, Seg0040     {  access ticker counter }
             MOV     BX, 6Ch         { offset of ticker counter in segm.}
             MOV     DX, 43h         { timer chip control port }
             MOV     AL, 4           { freeze timer 0 }
             PUSHF                   { save caller's int flag setting }
             CLI                     { make reading counter an atomic operation}
             MOV     DI, DS:[BX]     { read BIOS ticker counter }
             MOV     CX, DS:[BX+2]
             STI                     { enable update of ticker counter }
             OUT     DX, AL          { latch timer 0 }
             CLI                     { make reading counter an atomic operation}
             MOV     SI, DS:[BX]     { read BIOS ticker counter }
             MOV     BX, DS:[BX+2]
             IN      AL, 40h         { read latched timer 0 lo-byte }
             MOV     AH, AL          { save lo-byte }
             IN      AL, 40h         { read latched timer 0 hi-byte }
             POPF                    { restore caller's int flag }
             XCHG    AL, AH          { correct order of hi and lo }
             CMP     DI, SI          { ticker counter updated ? }
             JE      @no_update      { no }
             OR      AX, AX          { update before timer freeze ? }
             JNS     @no_update      { no }
             MOV     DI, SI          { use second }
             MOV     CX, BX          {  ticker counter }
@no_update:  NOT     AX              { counter counts down }
             MOV     BX, 36EDh       { load multiplier }
             MUL     BX              { W1 * M }
             MOV     SI, DX          { save W1 * M (hi) }
             MOV     AX, BX          { get M }
             MUL     DI              { W2 * M }
             XCHG    BX, AX          { AX = M, BX = W2 * M (lo) }
             MOV     DI, DX          { DI = W2 * M (hi) }
             ADD     BX, SI          { accumulate }
             ADC     DI, 0           {  result }
             XOR     SI, SI          { load zero }
             MUL     CX              { W3 * M }
             ADD     AX, DI          { accumulate }
             ADC     DX, SI          {  result in DX:AX:BX }
             MOV     DH, DL          { move result }
             MOV     DL, AH          {  from DL:AX:BX }
             MOV     AH, AL          {   to }
             MOV     AL, BH          {    DX:AX:BH }
             MOV     DI, DX          { save result }
             MOV     CX, AX          {  in DI:CX }
             MOV     AX, 25110       { calculate correction }
             MUL     DX              {  factor }
             SUB     CX, DX          { subtract correction }
             SBB     DI, SI          {  factor }
             XCHG    AX, CX          { result back }
             MOV     DX, DI          {  to DX:AX }
             POP     DS              { restore caller's data segment }
END;

procedure Wait(M: Longint);
 var
  S: Longint;
 begin
  S:=Clock;
  repeat until (Clock-S>M) or (Clock-S<0);
 end;
{$endif}
{$endif}
{$ifdef os2}
procedure wait(m: longint);
 begin
  dossleep(m);
 end;

function Clock;
 var
  A: Longint;
 begin
  DosQuerySysInfo(qsv_Ms_Count, qsv_Ms_Count, A, SizeOf(A));
  Clock:=A;
 end;
{$endif}

procedure IWannaDate(var D, M, Y: Word);
{$IFNDEF win32}
 var
  T: Word;
  aY, aM, aD, aT: xWord;
 begin
  GetDate(aY,aM,aD,aT);
  D:=aD;
  M:=aM;
  Y:=aY;
 end;
{$ENDIF}
{$IFDEF win32}
 begin
  DecodeDate(Date, Y, M, D);
 end;
{$ENDIF}

procedure IWannaTime(var H, M, S: Word);
 var
  T: xWord;
{$IFNDEF win32}
  aH, aM, _aS, _aT: xWord;
 begin
  GetTime(aH,aM,_aS,_aT);
  H:=aH;
  M:=aM;
  S:=_aS;
 end;
{$ENDIF}
{$IFDEF win32}
 begin
  DecodeTime(Time, H, M, S, T);
 end;
{$ENDIF}

function Str2Number(S: String): Boolean;
 var
  X: Longint;
{$IFDEF DPMI} C: Integer; {$ENDIF}
{$IFDEF MSDOS} C: Integer; {$ENDIF}
{$IFDEF OS2} C: Longint; {$ENDIF}
{$IFDEF WIN32} C: Integer; {$ENDIF}
 begin
  Val(S, X, C);
  Str2Number:=C=0;
 end;

{$ifdef win32}
function MemAvail: longint;
 var
  HeapStatus: THeapStatus;
 begin
  HeapStatus:=GetHeapStatus;
  MemAvail:=HeapStatus.TotalAddrSpace;
 end;

procedure FindFirst;
 begin
  DosError:=SysUtils.FindFirst(Mask, Attr, Sr);
 end;

procedure FindNext;
 begin
  DosError:=SysUtils.FindNext(Sr);
 end;

procedure FindClose;
 begin
  SysUtils.FindClose(Sr);
 end;
{$endif}

{$ifdef dpmi}
procedure FindClose;
 begin
 end;
{$endif}

{$ifdef msdos}
procedure FindClose;
 begin
 end;
{$endif}

function StackOverflow: boolean;
 begin
{$ifdef win32}
  StackOverflow:=False;
{$else}
  StackOverflow:=SPtr<$1000;
{$endif}
 end;

function RemoveBackSlash(S: String): String;
 begin
  S:=AddBackSlash(S);
  if S[0]>#3 then Dec(S[0]);
  RemoveBackSlash:=S;
 end;

function Str2Char(S: String): Char;
 begin
  if S[0]=#0 then
   Str2Char:=#0
  else
   Str2Char:=S[1];
 end;

function TimeFix: longint;
 var
  DT: DateTime;
  L: Longint;
 begin
  with DT do IWannaTime(Hour, Min, Sec);
  with DT do IWannaDate(Day, Month, Year);
  PackTime(DT, L);
  TimeFix:=L;
 end;

procedure TimeDif(L: Longint; var DT: DateTime);
 begin
  UnpackTime(L, DT);
  with DT do
   if Year >= 1980 then Dec(Year, 1980);
 end;

function GetFileSize(S: String): Longint;
 var
  Sr: SearchRec;
 begin
  FindFirst(S, AnyFile, Sr);
  if DosError<>0 then
   GetFileSize:=-1
  else
   GetFileSize:=sr.Size;
 end;

function GetPktDateTime: string;
 var
  Day, Month, Year, Hour, Min, Sec: Word;
 begin
  iWannaTime(Hour, Min, Sec);
  iWannaDate(Day, Month, Year);
  GetPktDateTime:=LeftPadCh(Long2Str(Day),'0',2)+' '+Copy(Months[Month],1,3)+' '+Copy(Long2Str(Year),3,2)+'  '+
     LeftPadCh(Long2Str(Hour),'0',2)+':'+LeftPadCh(Long2Str(Min),'0',2)+':'+LeftPadCh(Long2Str(Sec),'0',2);
 end;

function GetPktDateTimeCustom(Day, Month, Year, Hour, Min, Sec: Word): string;
 begin
  GetPktDateTimeCustom:=LeftPadCh(Long2Str(Day),'0',2)+' '+Copy(Months[Month],1,3)+' '+Copy(Long2Str(Year),3,2)+'  '+
     LeftPadCh(Long2Str(Hour),'0',2)+':'+LeftPadCh(Long2Str(Min),'0',2)+':'+LeftPadCh(Long2Str(Sec),'0',2);
 end;

const
 MonthsU : array[1..12] of string[3] = ('JAN','FEB','MAR','APR','MAY','JUN','JUL','AUG','SEP','OCT','NOV','DEC');

procedure ParsePktDateTime(S: String; var Day, Month, Year, Hour, Min, Sec, Dow: Word);
 var
  K: Byte;
 begin
  S:=StUpcase(S);
  Str2Word(ExtractWord(1, S, [' ',':']), Day);
  Month:=0;
  for K:=1 to 12 do if Copy(S, 4, 3) = MonthsU[K] then Month:=K;
  Str2Word(ExtractWord(3, S, [' ',':']), Year); if Year<81 then Inc(Year, 2000) else Inc(Year, 1900);
  Str2Word(ExtractWord(4, S, [' ',':']), Hour);
  Str2Word(ExtractWord(5, S, [' ',':']), Min);
  Str2Word(ExtractWord(6, S, [' ',':']), Sec);
  Dow:=DayOfWeek(Year, Month, Day);
 end;

function GetStamp(const FName: String): Longint;
{$IfDef Win32}
 var
  Handle: Integer;
 begin
  Handle:=FileOpen(FName, fmOpenWrite);
  GetStamp:=FileGetDate(Handle);
  FileClose(Handle);
 end;
{$Else}
 var
  F: File;
  K: Longint;
 begin
  {$I-}
  Assign(F, FName);
  Reset(F);
  if IOResult <> 0 then
   begin
    GetStamp:=-1;
    Exit;
   end;
  GetFTime(F, K);
  Close(F);
  GetStamp:=K;
 end;
{$EndIf}

procedure SetStamp(const FName: String; K: Longint);
{$IfDef Win32}
 var
  Handle: Integer;
 begin
  Handle:=FileOpen(FName, fmOpenWrite);
  FileSetDate(Handle, K);
  FileClose(Handle);
 end;
{$Else}
 var
  F: File;
 begin
  {$I-}
  Assign(F, FName);
  Reset(F);
  if IOResult <> 0 then Exit;
  SetFTime(F, K);
  Close(F);
  if IOResult <> 0 then;
 end;
{$EndIf}

{$IfDef Win32}
Function Clock: Longint;
 begin
  Clock:=TimeFix;
 end;

type
 DateTimeRec = record
  FTime,FDate: Word;
 end;

procedure UnpackTime(P: Longint; var T: DateTime);
var
  FDateTime: DateTimeRec absolute P;
begin
  with T,FDateTime do
  begin
    Year  :=  (FDate and mfdYear   ) shr sfdYear + 1980;
    Month :=  (FDate and mfdMonth  ) shr sfdMonth;
    Day   :=  (FDate and mfdDay    ) shr sfdDay;
    Hour  :=  (FTime and mftHours  ) shr sftHours;
    Min   :=  (FTime and mftMinutes) shr sftMinutes;
    Sec   := ((FTime and mftTwoSecs) shr sftTwoSecs) * 2;
  end;
end;

procedure PackTime(var T: DateTime; var P: Longint);
var
  FDateTime: DateTimeRec absolute P;
begin
  with T,FDateTime do
  begin
    FDate := (Year - 1980) shl sfdYear + Month shl sfdMonth + Day shl sfdDay;
    FTime := Hour shl sftHours + Min shl sftMinutes + (Sec div 2) shl sftTwoSecs;
  end;
end;

function GetEnv(const Name: String): String;
 var
  N, R: Array[0..255] of Char;
 begin
  StrPCopy(N, Name);
  if GetEnvironmentVariable(N, R, SizeOf(R)) = 0 then
   Result:=''
  else
   Result:=StrPas(R);
 end;
{$EndIf}
 
end.
